#!/usr/bin/perl -T
# $Id: main.cgi,v 1.30 2018/11/09 11:50:37 sofc Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Karin Soeren Koch           ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use ElchemeaHeader;
use ElchemeaUser;
use Elchemea;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use CGI qw(:standard :netscape);


if (param('ajax'))
{
    print header();
    unless (login_ok())
    {
	print "";
	exit;
    }
    my $a = param('action');
    if ($a && $a eq 'show_log')
    {
	my $u = param('user');
	exit unless (Elchemea::user_exist($u));
	my $user = ElchemeaUser->new($u);
	my $content = $user->get_sessionlog;
	print $content;
    }
    if ($a && $a eq 'add_log')
    {
	my $u = param('user');
	my $t = param('string');
	exit unless (Elchemea::user_exist($u));
	my $user = ElchemeaUser->new($u);
	$user->proglog('# '.$t) if ($t);
	my $content = $user->get_sessionlog;
	print $content;
    }
    if ($a && $a eq 'init')
    {
	my $u = param('user');
	print Elchemea::CGI_client('init',$u);
    }
    exit;
}


my $user;
my $bc_admin = undef;
if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    { 
	$user = ElchemeaUser->new(param('user'));
	&ElchemeaCGI::print_header("Elchemea main page",-onload=>'load_all()');   
	top_nav_bar_start();
	param(-name=>'action',-value=>'') unless (param('action'));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    /Create new/ and do {&create_form; last CASE;};
	    /Start new session/ and do {&create_new; last CASE;};
	    ### Default response ####
	    &main_page;
	}
	print_end();
    }
    else 
    {
	not_auth();
    }
}
    
exit;

sub create_new()
{
    my $name = param('name');
    unless ($name)
    {
	my $session = $user->session + 1;
	$name = "Session $session";
    }
    my $nr = param('number');
    if ($nr && $nr =~ /(\d+)/)
    {
	$nr = $1;
    }
    else
    {
	$nr = 0;
    }
    my $res;
    eval
    {
	$res = Elchemea::CGI_client('increase_test_nr',$user->name,$name,$nr);
    };
    if ($@ || !$res)
    {
	top_no_button();
	top_no_button();
	top_no_button();
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	top_no_button();
	top_no_button();
	top_no_button();
	top_nav_bar_button('main.cgi','','','To menu','s4');
	end_top_bar();
	print center(h2({-class=>'Alert'},"New session could not be created: $@"));	
    }
    else
    {
	top_nav_bar_button('misc.cgi','','','Miscellaneous setup','s9');
	top_nav_bar_button('about.cgi','','','About Elchemea','s2');
	top_nav_bar_button('setup_program.cgi','','','Setup program','s5');
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	ElchemeaCGI::create_menu_field;
	print button(-name=>'net',-value=>' ',-class=>'none',-id=>'net_status_btn',-onclick=>'activate_net()');
	top_nav_bar_button('','','action','Create new session','s3');
	top_nav_bar_button('view_session.cgi','','','Session view','s6');
	top_nav_bar_button('main.cgi','','','To menu','s4');
	end_top_bar();
	print center(h2("New session created"));
	$user->init();
    }
    &main_page('skip');
}



sub create_form()
{
    top_no_button();
    top_no_button();
    top_no_button();
    tab_newrow();
    js_back();
    top_js_return('#006600','white');
    top_no_button();
    top_no_button();
    top_no_button();
    top_nav_bar_button('main.cgi','','','To menu','s4');
    end_top_bar();
    print center(h2("Create new session"));
    print '<table class="tabel"><tr height=20>';
    print '<td width="20%"</td>';
    print '<td width="30%"</td>';
    print '<td width="30%"</td>';
    print '<td width="20%"</td>';
    print '</tr>';
    print start_form();
    print_hidden();
    print '<tr><td></td><th> Session name </th><td>';
    print textfield(-name=>'name',-value=>'',-force=>1,-class=>'textfield');
    print '</td></tr>';
    print '<tr><td></td><th> Optional start file number (default 0000)</th><td>';
    print textfield(-name=>'number',-value=>'0000',-force=>1,-class=>'textfield',-onchange=>'is_int(this)');
    print '</td></tr>';
    print '<tr><td colspan=2></td><td>';
    menu_button('action','Start new session','s4');
    print '</td></tr>';
    print end_form();
    print '</table>';
    print <<END;

<script language="javascript">

function load_all()
{
    /* Dummy function to satisfy header */
}

</script>

END

}

sub main_page
{
    unless ($user->session)
    {
	&create_form();
	return;
    }
    unless (@_)
    {
	top_nav_bar_button('misc.cgi','','','Miscellaneous setup','s9');
	top_nav_bar_button('about.cgi','','','About Elchemea','s2');
	top_nav_bar_button('setup_program.cgi','','','Setup program','s5');
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	ElchemeaCGI::create_menu_field;	
	my $RFCcontrol = Elchemea::get_config_value('global','fixed_RFCcontrol_url');
	if ($RFCcontrol)
	{
	    print start_form(-action=>$RFCcontrol);
	    print hidden(-name=>'name',-value=>param('user'),-force=>1);
	    my $pass = param('pass');
	    $pass = param('token') if (param('token'));
	    print hidden(-name=>'pass',-value=>$pass,-force=>1);
	    print submit(-name=>'To RFCcontrol',-class=>'s4');
	    if ($RFCcontrol =~ /rig\=(\d+)/)
	    {
		print hidden(-name=>'rig',-value=>$1,-force=>1);
	    }
	    print end_form();
	}
	else
	{
	    print button(-name=>'net',-value=>' ',-class=>'none',-id=>'net_status_btn',-onclick=>'activate_net()');
	}
	top_nav_bar_button('','','action','Create new session','s3');
	top_nav_bar_button('view_session.cgi','','','Session view','s6');
	top_nav_bar_button('main.cgi','','','To menu','s4');
	end_top_bar();
    }
    my $pot = Elchemea::new_PSTAT(Elchemea::get_config_value('equipment','potentiostat'),Elchemea::get_config_value('equipment','potentiostat_address'));
    my $fra = Elchemea::new_FRA(Elchemea::get_config_value('equipment','FRA'),Elchemea::get_config_value('equipment','FRA_address'));
    print '<center>';
    print '<table border=0 cellspacing=5 cellpadding=5 style="width:100%"><tr>';
    print '<td width="5%"></td>';
    print '<td width="30%"></td>';
    print '<td width="60%"></td>';
    print '<td width="5%"></td>';
    print '</tr>';
    print '</td></tr>';
    print '<tr><td></td><td valign=top>';
    print '<center>';
    print start_form(-class=>'form',-name=>'session');
    print_hidden();
    print h3('Session log for session '.$user->session.' , "'.$user->get_session_name().'"');
    print textarea(-name=>'test',-value=>'',-class=>'textfield',-rows=>'20',-force=>'1',-wrap=>'OFF');
    print button(-name=>'Add comment',-class=>'s3',-onclick=>'add_comment()');
    print end_form();
    print '</center>';
    print '</td><td valign=top>';
    print '<center>';
    my $header = 'Elchemea '.$Elchemea::VERSION;
    print h1({-id=>'header_content'},"$header");
    print '<table border=0 cellspacing=20 cellpadding=0>';
    print '<tr><td>';
    if ($fra->virtual)
    {
	print button(-name=>'dummy_btn',-value=>'',-class=>'m_none',-id=>'m_none');
    }
    else
    {
	&print_button('imp_conf.cgi','Setup impedance','m0') unless ($fra->virtual);
    }
    print '</td><td>';
    if ($pot->virtual)
    {
	print button(-name=>'dummy_btn',-value=>'',-class=>'m_none',-id=>'m_none');
    }
    else
    {
	&print_button('potsweep_conf.cgi','Setup potential sweep','m1');
    }
    print '</td><td>';
    if ($pot->virtual)
    {
	print button(-name=>'dummy_btn',-value=>'',-class=>'m_none',-id=>'m_none');
    }
    else
    {
	&print_button('chrono_conf.cgi',"Setup chrono",'m2');
    }
    print '</td></tr>';
    print '<tr><td>';
    if ($fra->virtual)
    {
	print button(-name=>'dummy_btn',-value=>'',-class=>'m_none',-id=>'m_none');
    }
    else
    {
	&print_button('run_imp.cgi','Run impedance','hidden');
    }
    print '</td><td>';
    if ($pot->virtual)
    {
	print button(-name=>'dummy_btn',-value=>'',-class=>'m_none',-id=>'m_none');
    }
    else
    {
	&print_button('run_potsweep.cgi','Run potential sweep','hidden');
    }
    print '</td><td>';
    if ($pot->virtual)
    {
	print button(-name=>'dummy_btn',-value=>'',-class=>'m_none',-id=>'m_none');
    }
    else
    {
	&print_button('run_chrono.cgi','Run chrono','hidden');
    }
    print '</td></tr>';
    print '<tr><td>';
    print start_form(-action=>'run_single.cgi',-name=>'run_single_form');
    print_hidden();
    print hidden(-name=>'freq',-value=>1000,-force=>1);
    print hidden(-name=>'number',-value=>10,-force=>1);
    print button(-name=>'single',-value=>'Run single frequency',-class=>'hidden',-onclick=>'run_single_freq()',-id=>'single') unless ($fra->virtual);
    print end_form();
    print '</td><td>';
    print start_form();
    print button(-name=>'init',-value=>'Initialise devices',-class=>'hidden',-onclick=>'init_dev()',-id=>'init');
    print end_form();
    print '</td><td>';
    print start_form();
    print button(-name=>'square',-value=>'Run square function',-class=>'hidden',-onclick=>'run_square()',-id=>'square') unless ($pot->virtual);
    print end_form();
    print '</td></tr>';
    print '</table>';
    print h3({-id=>'Net_status'}," ");
    print '</center>';
    print '</td></tr>';
    print '</table>';
    print '</center>';
    my $arrstr = "var arr = [];\n";
    $arrstr .= "arr[0] = 'Run_impedance';\n" unless ($fra->virtual);
    $arrstr .= "arr[1] = 'Run_potential_sweep';\n" unless ($pot->virtual);
    $arrstr .= "arr[2] = 'Run_chrono';\n" unless ($pot->virtual);
    $arrstr .= "arr[3] = 'init';\n"; 
    $arrstr .= "arr[4] = 'square';\n" unless ($pot->virtual);
    $arrstr .= "arr[5] = 'single';\n" unless ($fra->virtual); 

    print <<END;

<script language="javascript">

var running = 0;

function run_single_freq()
{
    var form = document.run_single_form;
    if (running == 1)
    {
	form.submit();
	return true;
    }
    var freq = prompt("Frequency?",form.freq.value);
    if (freq == '' || freq == null)
    {
	return false;	
    }
    var n = prompt("Number of points?",form.number.value);
    if (n == '' || n == null)
    {
	return false;	
    }
    form.freq.value = freq;
    form.number.value = n;
    running = 1;
    form.submit();
}

function square_start(t)
{
    alert('Square waveform output started');
    load_log(t)
}

function run_square()
{
    var pol = prompt("Square wave polarisation?",'0.01');
    run_ajax('run_square.cgi','&pol='+pol,square_start);	
}


var net = 0;

var names = [];

var n = [];

n[0] = "Impedance";
n[1] = "Potsweep";
n[2] = "Chrono";
n[3] = "Init";
n[4] = "Square";
n[5] = "Single";

var content = "$header";

$arrstr


var cl = [];
cl[0] = "m3";
cl[1] = "m4";
cl[2] = "m5";
cl[3] = "m6";
cl[4] = "m7";
cl[5] = "m8";

function load_all()
{
    for (var i = 0; i< arr.length;i++)
    {
	if (arr[i] != null)
	{	
	    var name = arr[i];
	    var obj = document.getElementsByName(name).item(0);
	    names[i] = obj.value;
	}
    }
    load_log();
    load_status();
    load_net_status();
}

function activate_net()
{
    if (net == 0)
    {
	return false;
    }
    var btn = document.getElementById('net_status_btn');
    btn.setAttribute("class","none");
    btn.setAttribute("className","none");
    if (net == 1)
    {
	net = 0;
	run_ajax('net_status.cgi','&action=OFF',set_net_status);
    }
    if (net == -1)
    {
	net = 0;
	run_ajax('net_status.cgi','&action=ON',set_net_status);	
    }
}

function set_log(t)
{
    document.session.test.value = t;
}

function init_dev()
{
    run_ajax('main.cgi','&action=init',alert);
}

function load_log()
{
    run_ajax('main.cgi','&action=show_log',set_log);
    setTimeout("load_log()",60000);
}

function add_comment()
{
    var text = prompt("New comment:");
    if (text == null)
    {
	return false;
    }
    run_ajax('main.cgi','&action=add_log&string='+text,set_log);
}

function load_status()
{
    run_ajax('runstatus.cgi','&action=status',set_status);
    setTimeout("load_status()",1000);
}

function load_net_status()
{
    run_ajax('net_status.cgi','&action=status',set_net_status);
}


function set_net_status(s)
{
    var res = s.split("\\n");
    var obj = document.getElementById('Net_status');
    var btn = document.getElementById('net_status_btn');
    btn.setAttribute("class","s1");
    btn.setAttribute("className","s1");
    if (res[0] == "ERROR")
    {
	alert(s);
	return false;
    }
    if (res[0] == "ON")
    {
	net = 1;
	obj.innerHTML = res[1]; 
	btn.value = "Disconnect from network";
    }
    else
    {
	net = -1;
	obj.innerHTML = " "; 
	btn.value = "Connect to network";
    }
}

function set_status(s)
{
    var res = s.split("\\n");
    if (res[0] == "Free")
    {
	running = 0;
	document.getElementById('header_content').innerHTML = content;
	for (var i = 0; i< arr.length;i++)
	{
	    if (arr[i] != null)
	    {
		var name = arr[i];
		var obj = document.getElementById(name);
		obj.setAttribute("class",cl[i]);
		obj.setAttribute("className",cl[i]);
		obj.value = names[i];
	    }
	}
    }
    else
    {
	running = 1;
	document.getElementById('header_content').innerHTML = content + " "+ res[0];
	var j = -1;
	for (var i = 0; i< arr.length;i++)
	{
	    if (arr[i] != null)
	    {
		var name = arr[i];
		var obj = document.getElementById(name);
		obj.setAttribute("class","hidden");
		obj.setAttribute("className","hidden");
		if (n[i] == res[1])
		{
		    j = i;
		}
	    }
	}
	if (j != -1)
	{
	    var name = arr[j];
	    var obj = document.getElementById(name);
	    obj.setAttribute("class",cl[j]);
	    obj.setAttribute("className",cl[j]);	
	    obj.value = "Show "+n[j];
	}
    }
}

</script>

END

}

sub print_button()
{
    my $file = shift;
    my $text = shift;
    my $class = shift;
    my $n = $text;
    $n =~ s/\s+/_/g;
    print start_form(-action=>$file,-class=>'form',-name=>'form_'.$n);
    &print_hidden();
    print submit(-name=>$n,-value=>$text,-class=>$class,-id=>$n);
    print end_form;
    print "\n";
}

