#!/usr/bin/perl
use strict;
use warnings;
use Elchemea;
use ElchemeaUser;
use ElchemeaCGI qw(:DEFAULT :cgi :html);
use ElchemeaHeader;
use CGI qw(:standard :netscape);

my $user;
if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    {
	$user = ElchemeaUser->new(param('user'));
	&print_header("Elchemea Impedance",-onload=>'load_start()');
	print <<END;

<script language="javascript">

function load_start()
{
    setTimeout("reloadInfo()", 2500);
    reloadImage();
}

</script>

END

        top_nav_bar_start();
	top_no_button();
        top_no_button();
        top_no_button();
        tab_newrow();
        js_back();
        top_js_return('#006600','white');
        top_no_button();
        top_nav_bar_button('show_file.cgi','','action','Stop measurement','s0');
        top_no_button();
        top_nav_bar_button('main.cgi','','','To menu','s4');
        end_top_bar();
	unless (Elchemea::is_locked)
	{
	    if (-e $programlock)
	    {
		print h1({-class=>'Alert'},"Program is currently running, Impedance not started!");
	    }
	    else
	    {
		Elchemea::CGI_client('impedance',$user->name,$user->session);
		sleep(2);
	    }
	}
	&main();
        print_end();
    }
    else
    {
        not_auth();
    }
}

exit;


sub main()
{
    print '<center>';
    print h1("Running Impedance");
    print start_form(-name=>'main');
    print_hidden();
    print '<table class="tabel"><tr>';
    print '<td width="5%"></td>';
    print '<td width="40%"></td>';
    print '<td width="50%"></td>';
    print '<td width="5%"></td>';
    print '</tr>';
    print '<tr><td></td><td valign=top>';
    print '<table class="tabel""><tr>';
    print '<td width=40%></td>';
    print '<td width=60%></td>';
    print '</tr>';
    print '<tr><th> User: </th><th id="username"> </th></tr>';
    print '<tr><th> Filename: </th><th id="file"> </th></tr>';
    print '<tr><th> Status: </th><th id="status"> </th></tr>';
    print '<tr><th> Estimated time remaining: </th><th id="remaining"> </th></tr>';
    print '<tr><th> Measurement mode: </th><th id="mode"> </th></tr>';
    print '<tr><th> Frequency: </th><th id="freq"> </th></tr>';
    print '<tr><th> Real: </th><th id="real"> </th></tr>';
    print '<tr><th> Imaginary: </th><th id="imag"> </th></tr>';
    print '<tr><th> Last error: </th><th id="error"> </th></tr>';
    print '<tr><th> Last warning: </th><th id="warning"> </th></tr>';
    print '<tr><th> Points remaining: </th><th id="points"> </th></tr>';
    print '</table>';

    print '</td><td valign=top>';
    print '<center>';
    print '<img name="measure_img" src="/elchemea/png/current.png">';
    print '<center>';
    print '</table>';
    print end_form;
    print '</center>';
    print start_form(-action=>'show_file.cgi',-name=>'finish');
    print_hidden();
    &action('show_file');
    print hidden(-name=>'session',-value=>$user->session,-force=>1);
    print hidden(-name=>'file',-value=>$user->get_measure_nr,-force=>1);
    print end_form;
    print <<END;

<script language="javascript">

function set_info(s)
{
    var arr = s.split("\\n");
    for (var i=arr.length;i<11;i++)
    {
	arr.push('');
    }
    var file = 's'+arr[0]+"_"+arr[1]+".i2b";
    document.getElementById("file").innerHTML = file;
    document.getElementById("remaining").innerHTML = arr[3];
    document.getElementById("status").innerHTML = arr[4];
    document.getElementById("username").innerHTML = arr[5];
    document.getElementById("mode").innerHTML = arr[6];
    if (arr[7].length > 3)
    {
	var data = arr[7].split(" ");
	document.getElementById("freq").innerHTML = data[0];
	document.getElementById("real").innerHTML = data[1];
	document.getElementById("imag").innerHTML = data[2];
    }
    if (arr[8] != "")
    {
	document.getElementById("error").innerHTML = arr[8];
    }
    if (arr[9] != "")
    {
	document.getElementById("warning").innerHTML = arr[9];
    }
    if (arr[10] != "")
    {
	document.getElementById("points").innerHTML = arr[10];
    }
    if (arr[4] == "Finished")
    {
	document.finish.submit();
    }
}

function reloadInfo()
{
    run_ajax('runinfo.cgi','&action=runinfo',set_info);
    setTimeout("reloadInfo()", 1000);
}

function reloadImage()
{
    img = document.main.measure_img;
    img.src = '/elchemea/png/current.png?' + Math.random();
    setTimeout("reloadImage()", 500);
}

</script>

END

}
