#!/usr/bin/perl
#$Id: update_wsdl.pl,v 1.5 2018/09/19 06:25:06 sqko Exp $
use strict;
use warnings;
use Pod::WSDL;
use Sys::Hostname;
my $html_path = shift;
my $cgi_path = '';
my @list = ('elchemea.cgi');
if ($html_path && $html_path =~ /(.*)\/html\//)
{
    $cgi_path = $1.'/cgi-bin/elchemea/';
}
my $host = hostname();
foreach my $f (@list)
{
    my $file = $cgi_path.$f;
    $f =~ /(.*)\.cgi/;
    my $out = $html_path.'/'.$1.'.wsdl';
    next unless -e $file;
    my $url = $file;
    $url =~ s/.*cgi-bin/cgi-bin/;
    $url = 'https://'.$host.'/'.$url;
    my $pod = new Pod::WSDL(
        source => $file, 
        location => $url,
        pretty => 1,
        withDocumentation => 1,
			    );
    my $content = $pod->WSDL;
    ## Fix HandlerService line to be unique across multiple servers ##
    $content =~ s/HandlerService/HandlerService$host/;
    open OUT,'>',$out or die "Could not open file $out for writing $!\n";
    print OUT $content;
    close OUT;
}
